@echo off
set num=1

set SA8=c:\sybase\asa803\win32
set SA12=c:\sybase\asa12m\bin32

rem  Delete databases from old runs
"%SA8%\dbstop" -y -c "eng=cons;dbn=cons;uid=cons;pwd=sql"
"%SA12%\dbstop" -y -c "eng=cons;dbn=cons;uid=cons;pwd=sql"
"%SA12%\dberase" -y cons\cons.db
for /L %%i in (1,1,%num%) do "%SA12%\dberase" -y rem%%i\rem%%i.db
"%SA12%\dberase" -y aes_cons\cons.db
for /L %%i in (1,1,%num%) do "%SA12%\dberase" -y aes_rem%%i\rem%%i.db

rem  Remove all left over messages and directories
erase /Q /F cons
for /L %%i in (1,1,%num%) do erase /Q /F rem%%i
erase /Q /F aes_cons
for /L %%i in (1,1,%num%) do erase /Q /F aes_rem%%i
erase /Q /F messages\cons
for /L %%i in (1,1,%num%) do erase /Q /F messages\rem%%i
erase /Q /F messages

rmdir cons
for /L %%i in (1,1,%num%) do rmdir rem%%i
rmdir aes_cons
for /L %%i in (1,1,%num%) do rmdir aes_rem%%i
rmdir messages\cons
for /L %%i in (1,1,%num%) do rmdir messages\rem%%i
rmdir messages

rem  Make sure you do not delete these files
attrib -r *.*
attrib +r *.bat
attrib +r *.sql
echo y|del *.*
attrib -r *.bat
attrib -r *.sql

rem  Create directories for the database files

mkdir cons
for /L %%i in (1,1,%num%) do mkdir rem%%i

rem  Create the message directory structure

mkdir messages
mkdir messages\cons
for /L %%i in (1,1,%num%) do mkdir messages\rem%%i

rem  Now set the SQLREMOTE environment variable to point to the messages directory

SET SQLREMOTE=messages

rem  Now we create the empty database files.  

if not exist tempDB mkdir tempDB
if not exist tempDB\cons.db "%SA8%\dbinit" tempDB\cons.db -e

copy tempDB\cons.db cons\cons.db
for /L %%i in (1,1,%num%) do copy tempDB\cons.db rem%%i\rem%%i.db
"%SA8%\dblog" -t cons.log cons\cons.db
for /L %%i in (1,1,%num%) do "%SA8%\dblog" -t rem%%i.log rem%%i\rem%%i.db

"%SA8%\dbspawn" -f "%SA8%\dbsrv8" -gd all -x none -n cons

start /wait "" "%SA8%\dbisqlc" -c "uid=dba;pwd=sql;eng=cons;dbn=cons;dbf=cons\cons.db;autostop=no" read cons.sql %num%
for /L %%i in (1,1,%num%) do start /wait "" "%SA8%\dbisqlc" -c "uid=dba;pwd=sql;eng=cons;dbn=rem%%i;dbf=rem%%i\rem%%i.db;autostop=no" read rem.sql %%i

start /wait "" "%SA8%\dbremote" -c "uid=cons;pwd=sql;eng=cons;dbn=cons" -k -v -o cons_803.txt
for /L %%i in (1,1,%num%) do start /wait "" "%SA8%\dbremote" -c "uid=cons;pwd=sql;eng=cons;dbn=rem%%i" -k -v -o rem%%i_803.txt
start /wait "" "%SA8%\dbremote" -c "uid=cons;pwd=sql;eng=cons;dbn=cons" -k -v -o cons_803.txt
for /L %%i in (1,1,%num%) do start /wait "" "%SA8%\dbremote" -c "uid=cons;pwd=sql;eng=cons;dbn=rem%%i" -k -v -o rem%%i_803.txt

@rem
@rem Generate a bunch of offline v8 logs that still need to be scanned
@rem
start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=cons" call rep_data(10)
for /L %%i in (1,1,%num%) do start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=rem%%i" call rep_data(10)
start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=cons" BACKUP DATABASE DIRECTORY '' TRANSACTION LOG ONLY TRANSACTION LOG RENAME
for /L %%i in (1,1,%num%) do start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=rem%%i" BACKUP DATABASE DIRECTORY '' TRANSACTION LOG ONLY TRANSACTION LOG RENAME
start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=cons" call rep_data(10)
for /L %%i in (1,1,%num%) do start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=rem%%i" call rep_data(10)
start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=cons" BACKUP DATABASE DIRECTORY '' TRANSACTION LOG ONLY TRANSACTION LOG RENAME
for /L %%i in (1,1,%num%) do start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=rem%%i" BACKUP DATABASE DIRECTORY '' TRANSACTION LOG ONLY TRANSACTION LOG RENAME

@rem
@rem Rebuild the databases to use strong encryption
@rem
"%SA8%\dbstop" -y -c "eng=cons;dbn=cons;uid=cons;pwd=sql"
"%SA12%\dbunload" -c "uid=dba;pwd=sql;dbf=cons\cons.db" -ar -ea aes256 -ek sql
for /L %%i in (1,1,%num%) do "%SA12%\dbunload" -c "uid=dba;pwd=sql;dbf=rem%%i\rem%%i.db" -ar -ea aes256 -ek sql
"%SA12%\dbspawn" -f "%SA12%\dbsrv12" -gd all -x none -n cons

@rem
@rem Generate a bunch of offline v12 logs that still need to be scanned
@rem
start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=cons;dbf=cons\cons.db;autostop=no;dbkey=sql" call rep_data(10)
for /L %%i in (1,1,%num%) do start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=rem%%i;dbf=rem%%i\rem%%i.db;autostop=no;dbkey=sql" call rep_data(10)
start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=cons" BACKUP DATABASE DIRECTORY '' TRANSACTION LOG ONLY TRANSACTION LOG RENAME
for /L %%i in (1,1,%num%) do start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=rem%%i" BACKUP DATABASE DIRECTORY '' TRANSACTION LOG ONLY TRANSACTION LOG RENAME
start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=cons" call rep_data(10)
for /L %%i in (1,1,%num%) do start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=rem%%i" call rep_data(10)
start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=cons" BACKUP DATABASE DIRECTORY '' TRANSACTION LOG ONLY TRANSACTION LOG RENAME
for /L %%i in (1,1,%num%) do start /wait "" "%SA8%\dbisqlc" -c "uid=cons;pwd=sql;eng=cons;dbn=rem%%i" BACKUP DATABASE DIRECTORY '' TRANSACTION LOG ONLY TRANSACTION LOG RENAME

@rem
@rem Run v12 dbremote with the encyption key and scan v8 and v12 logs
@rem
start /wait "" "%SA12%\dbremote.exe" -c "uid=cons;pwd=sql;eng=cons;dbn=cons" -qc -o cons_1201.txt -v -ek sql
for /L %%i in (1,1,%num%) do start /wait "" "%SA12%\dbremote.exe" -c "uid=cons;pwd=sql;eng=cons;dbn=rem%%i" -qc -o rem%%i_1201.txt -v -ek sql
start /wait "" "%SA12%\dbremote.exe" -c "uid=cons;pwd=sql;eng=cons;dbn=cons" -qc -o cons_1201.txt -v -ek sql
for /L %%i in (1,1,%num%) do start /wait "" "%SA12%\dbremote.exe" -c "uid=cons;pwd=sql;eng=cons;dbn=rem%%i" -qc -o rem%%i_1201.txt -v -ek sql
